# $Date: 1996/09/19 08:47:11 $ $Author: frankp $ $Revision: 1.3 $ #

#--
	tanh/rectform -- the function attribut "rectform" for tanh
--#

tanh:= funcattr( tanh, "rectform", proc(x)
	name tanh::rectform;
        local a, b, t, rl;
    begin
        if args(0) = 2 then
            x:= rectform::new(x,args(2))
        else
            x:= rectform::new(x)
        end_if;
        rl:= extop(x,4);
        if extop(x,3) <> 0 then
            new(rectform,0,0,hold(tanh)(rectform::expr(x)),rl)
        else
            a:= extop(x,1);
            b:= extop(x,2);
            if domtype(a+I*b) = DOM_COMPLEX
            and (domtype(a) = DOM_FLOAT or domtype(b) = DOM_FLOAT)
            then
                rectform::new(tanh(a+I*b))
            elif iszero(b) then
                new(rectform,tanh(a),0,0,rl)
            else
                t:= sinh(2*a)+cos(2*b);
                new(rectform,sinh(2*a)/t,sin(2*b)/t,0,rl)
            end_if
        end_if
    end_proc
):

# end of file #
