# $Date: 1996/12/05 16:45:49 $ $Author: frankp $ $Revision: 1.5.2.1 $ #

#++
	numeric -- functions for numerical mathematics
++#

proc()
    local path;
begin

numeric:= domain("numeric"):
numeric::info:= "Library 'numeric': functions for numerical mathematics":
numeric::interface:= { 
    hold(fsolve), hold(newton), hold(bairstow), hold(lagrange)
}:

path := pathname("NUMERIC");

numeric::complex_round:= loadproc(numeric::complex_round,path,"cmplxrnd"):
numeric::fsolve:= loadproc(numeric::fsolve,path,"fsolve"):
numeric::newton:= loadproc(numeric::newton,path,"newton"):
numeric::bairstow:= loadproc(numeric::bairstow, path, "Bairstow"):
numeric::fsolve_Sqrfpoly:= loadproc(numeric::fsolve_Sqrfpoly,path,"solvepol"):
numeric::lagrange:= loadproc(numeric::lagrange, path, "interp"):

stdlib::LoadlibState["numeric"]:= TRUE:

end_proc():

# end of file #
